Page MenuHome

Bake animation does not bake custom properties on bones on new action
Closed, ArchivedPublic

Description

System Information
Operating system: Win 10
Graphics card: Nvidia GTX 1070

Blender Version
Broken: 2.80, c13e10a7404d, Branch:blender2.7 , 2019-06-04 00:52, as found on the splash screen

Short description of error
When baking animation to new action (from NLA editor) custom properties on bones will not be keyed and baked down.

Exact steps for others to reproduce the error
Create 2 bones with one bone having a custom property on in the bone tab. Drive another bones position or rotation with that custom property. Set keys and change the value of the custom property over time. Create an NLA track from the current action. Select all bones in the armature and bake using the "pose" setting and "selected bones" options. Observe that in the new action, only translation, rotation and scale will be keyed, leaving the custom property unkeyed. When muting the original NLA track, the driven animation will no longer play.

Event Timeline

Sebastian Parborg (zeddb) lowered the priority of this task from 90 to 30.Jul 9 2019, 3:20 PM

Could you attach a minimal .blend file where we can just open the file and press bake to observe the issue?

Certainly. I've replicated it with the standard rigify rig. If you notice, when merging the NLA strips and muting the two NLA tracks, the IK key switch doesn't get baked and transferred up to the new action.

Isn't this expected? The tool tip for Bake Action specifically says that it will only bake loc/rot/scale...

Actually you’re right, I guess this would be a requested feature.

Sebastian Parborg (zeddb) changed the task status from Unknown Status to Unknown Status.Jul 11 2019, 2:21 PM
Sebastian Parborg (zeddb) claimed this task.

Hello, I just hit this today and found this bug entry. Did this get added as a feature request somewhere I am not finding it? Thank you.

I too would like to know if this has since been added as a feature or feature request. Not being able to bake blend shapes tied to custom controls is very annoying.

I think it is solved in the https://developer.blender.org/D8867 improvements going on from @Wayde Moss (GuiltyGhost) and or is where it should go possibly since it is an issue when trying to combine actions.

A bit of miscommunication. I sent that link just to show where to look for adding the support you're looking for.

Has anyone tested the D8867 build to see if it solves the problem?

Ah, sorry, yes I misunderstood. It makes sense to me that it would go in with the layer merge bake feature possibly so that custom property animation can be properly combined to new actions.
I haven't yet tested the D8867 to see if it worked.

any news on this? working on a feature that uses stepped animation, and all my animation of custom properties is getting lost on baking it is utterly annoying....

I'm trying to apply Rigify character to Unreal Engine workflow for my team project.
For the maintenance of complex movements, I organized my animation using NLA and tried to bake it as an action for export to Unreal Engine when the animation was completed.
However, bake action operation of Blender doesn't take into account custom properties, so Rigify's IK-FK conversion, parent retarget, neck/head follow and etc features were ignored, The final animation loses its expressiveness and I lead to a dead end to workflow planning.
It would be great if the Bake Action operation works with custom properties.

How come it is closed while the issue has not been resolved, is it being tracked elsewhere ?
I am dealing with this on 3.1.0 still. The fact that FK IK switching won't get baked to a single layer is quite a handicap to work with.

It is closed because it is considered a "Feature request" as the Bake action tool wasn't designed to work that way, it is considered not a bug or broken. It is on the list of things that need to be addressed from the animation module and part of the NLA redesign.